/*
 *			memory.h
 * $Id: memory.h,v 1.3 2004/01/06 03:36:11 hiddy Exp $
 * Copyright (C) 2003 Hideaki Imaizumi <hiddy@sfc.wide.ad.jp>
 *               All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _MALLOC_H_
#define _MALLOC_H_

/* memory debugger */
#define MALLOC(x, y)	xpdic_malloc(x, y, __FILE__, __LINE__)
#define FREE(x, y)   	xpdic_free(x, y, __FILE__, __LINE__)
#define xp_strdup(x)	_xp_strdup(x, __FILE__, __LINE__)
#define xp_strfree(x)	_xp_strfree(x, __FILE__, __LINE__)

extern void *(*xpdic_malloc)(const char *, size_t, const char *, int);
extern void (*xpdic_free)(const char *, void *, const char *, int);

inline static char *_xp_strdup(const char *p, const char *f, int l){
	char *ret = xpdic_malloc("string", strlen(p) + 1, f, l), *q;
	q = ret;
	while(*p)
		*q++ = *p++;
	return ret;
}
inline static void _xp_strfree(const char *p, const char *f, int l){ 
	xpdic_free("string", (void *)p, f, l); 
}

extern void (*memdump)(void);/* dump memory allocation status */
#endif /* _MALLOC_H_ */

