/*
 *			ndtpbook.h
 * $Id: ndtpbook.h,v 1.4 2004/01/11 07:21:00 hiddy Exp $
 * Copyright (C) 2003 Hideaki Imaizumi <hiddy@sfc.wide.ad.jp>
 *               All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _XP_NDTP_BOOK_
#define _XP_NDTP_BOOK_
struct dictbook;
struct ndtpserver;

/* dictionary book via NDTP */
struct ndtpbook {
	struct dictbook    ndb_base;

	struct ndtpserver *ndb_server;
	int		   ndb_index;	/* index for this book on the server */
	const char 	  *ndb_id;	/* id for this book on the server */

	/* cache */
	void 		  *ndb_cache;
	const char	  *ndb_cachedir; /* path to cache dir */
};

#define ndb_name		ndb_base.db_name
#define ndb_glid		ndb_base.db_glid
#define ndb_errno		ndb_base.db_errno
#define ndb_nfontsize		ndb_base.db_nfontsize
#define ndb_fontsizelist	ndb_base.db_fontsizelist
#define ndb_open		ndb_base.db_open
#define ndb_close		ndb_base.db_close
#define ndb_free		ndb_base.db_free
#define ndb_reclaim		ndb_base.db_reclaim
#define ndb_lookup		ndb_base.db_lookup
#define ndb_getentry		ndb_base.db_getentry
#define ndb_getbitmap		ndb_base.db_getbitmap
#define ndb_strerr		ndb_base.db_strerr

/* this function must be called by only ndtpserver */
struct ndtpbook *ndtpbook_new(struct ndtpserver *, const char *name, int idx, const char *id);

/* 
 * this funciton is also called by only ndtpserver. the difference between 
 * this and ndb_free() is that only ndb_free() erases the book in booklist
 * contained by ndtpserver.
 */
void		 ndtpbook_free(struct dictbook *);
#endif /* _XP_NDTP_BOOK_ */
