/*
 *			xpopdic_component.h
 * $Id: xpopdic_component.h,v 1.6 2004/01/23 02:45:27 hiddy Exp $
 * Copyright (C) 2003 Hideaki Imaizumi <hiddy@sfc.wide.ad.jp>
 *               All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
#ifndef _XP_COMPONENT_H_
#define _XP_COMPONENT_H_
struct xpopdic_control;

/* structure containing all components for xpopdic */
struct xpopdic_component {
	/* string cache */
	strset			xo_strs;

	/* xobject cache for linked word/number */
	xobjcache		xo_words;

	/* basic xobject */
	xobject			*xo_expdr;	/* expander */
	xobject			*xo_space;	/* space for sentence */
	xobject			*xo_colon;	/* colon separator */
	xobject			*xo_slash;	/* slash separator */
	xobject			*xo_bottom;	/* bottom mark */

	/* clickable entry pointer */
	xobject			*xo_ptr;	/* entry pointer */

	/* 
	 *  xobject components for xpopdic: (xposmark *) 
	 * these components contains x absolute position inside so 
	 * when a page changes, the page must be relocate to update
	 * these positions.
	 */
	xobject			*xo_up;		/* up button */
	xobject			*xo_next;	/* next button */
	xobject			*xo_prev;	/* prev button */
	xobject			*xo_quit;	/* quit button */
	xobject			*xo_status;	/* status bar */

	/* search page */
	xobject			*xo_search;	/* search page */
};

#endif /* _XP_COMPONENT_H_ */
