/*
 *			xpopdic_resource.h
 * $Id: xpopdic_resource.h,v 1.9 2004/01/24 11:53:34 hiddy Exp $
 * Copyright (C) 2003 Hideaki Imaizumi <hiddy@sfc.wide.ad.jp>
 *               All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
#ifndef _XP_RESOURCE_H_
#define _XP_RESOURCE_H_

/* all resource structure */
struct xpopdic_resource {
	/* important information */
	int		x, y;		/* position to popup: */
					/* -1 means following mouse. */
	int		width;		/* width of xpopdic window */
	int		height;		/* height of xpopdic window */
	int		bdwidth;	/* border width */
	int		bodybdwidth;	/* body border width */
	int		bsidemargin;	/* body side margin */
	int		btbmargin;	/* body top/bottom margin */
	int		intval;		/* interval to check cutbuffer. */
	int		bodywidth;	/* body width */

	long		bgc;		/* background pixel */
	long		bdc;		/* border pixel */

	/* options: not0=enable, 0=disable */
	int		notitle;	/* no title */
	int		nosubinfo;	/* no subinfo */
	int		shadow;		/* use window shadow */
	int		quitonleave;	/* quit on leave out of window */
	int		browsable;	/* word browsable */

	/* xattributes for fonts */
	xattr		*xattitle;	/* title attributes */
	xattr		*xatsubinfo;	/* subinfo attributes */
	xattr		*xatdict;	/* dictionary attributes */
	xattr		*xatstat;	/* status attributes */
	xattr		*xatbody;	/* font in body attributes */
	xattr		*xatwbody;	/* body for wide characters */
	xattr		*xatclick;	/* clicked body font */
	xattr		*xatwclick;	/* clicked for wide char */
	xattr		*xatgaiji;	/* gaiji font */
	xattr		*xatptr;	/* gaiji pointer font */

	/* xattributes for search window */
	xattr		*xatblack;	/* black */
	xattr		*xatwhite;	/* white */
	xattr		*xatblue;	/* blue */
	xattr		*xaturl;	/* url */

	/* body color */
	xattr		*xatborder;	/* Border Line color */
	xattr		*xatbodybdc;	/* Body Border Line */
	xattr		*xatbodybgc;	/* Border Line color */

	/* xattributes for each glass icon */
	xattr		*xatglass1;
	xattr		*xatglass2;
	xattr		*xatglass3;
	xattr		*xatglass4;

	/* xattribute for icon */
	xattr		*xaticon;
	xattr		*xaticon_clicked;

	/* icons */
	struct bitmap 	*up;		/* up icon */
	struct bitmap 	*quit;		/* quit icon */
	struct bitmap 	*next;		/* next icon */
	struct bitmap 	*prev;		/* prev icon */

	struct bitmap 	*entptr1;	/* entry poiner icon */
	struct bitmap 	*entptr2;	/* entry poiner icon(enter) */
	struct bitmap 	*entptr3;	/* entry poiner icon(clicked) */

	struct bitmap 	*glass1;	/* glass icon for status bar */
	struct bitmap 	*glass2;	/* glass icon for status bar */
	struct bitmap 	*glass3;	/* glass icon for status bar */
	struct bitmap 	*glass4;	/* glass icon for status bar */
};

#endif /* _XP_RESOURCE_H_ */
