/*
 *                      xppage_list.c
* $Id: xppage_list.c,v 1.8 2004/01/24 11:53:34 hiddy Exp $
 * Copyright (C) 2003 Hideaki Imaizumi <hiddy@sfc.wide.ad.jp>
 *               All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <stdio.h>
#include <string.h>
#include "memory.h"
#include "bitmap.h"
#include "dictbook.h"
#include "booklist.h"
#include "dictlink.h"
#include "strlist.h"
#include "strset.h"
#include "xobjcache.h"
#include "xwindow.h"
#include "stk/stkbase.h"
#include "xpopdic_resource.h"
#include "xpopdic_component.h"
#include "xpopdic_control.h"
#include "xpobject.h"
#include "xpaction.h"
#include "xppage.h"
#define mkstr(x,y)	xstring_na_new(x, strlen(x), y, 0)


xobject *
xppage_list_border(struct xpopdic_control *cp, struct dictnode *dnode)
		
{
	int w;
	xobject *border = xhlayout_new(cp->xpr->width, -1, 0, XCRULE_CENTER);
	xobject *nent, *entstr;

	xcont_add(border, xline_new(0, 0, 20, 0, cp->xpr->xatborder), 
		  XCRULE_CENTER);
	xcont_add(border, xspace_new(15, 4), XCRULE_CENTER);
	xcont_add(border, cp->xpc->xo_expdr, XCRULE_CENTER);
	nent = mkstr(num2str[dnode->dn_number], cp->xpr->xatsubinfo);
	xcont_add(border, nent, XCRULE_CENTER);
	xcont_add(border, mkstr(" ", cp->xpr->xatsubinfo), XCRULE_CENTER);
	if(dnode->dn_number == 1)
		entstr = mkstr("Entry", cp->xpr->xatsubinfo);
	else 
		entstr = mkstr("Entries", cp->xpr->xatsubinfo); 
	xcont_add(border, entstr, XCRULE_CENTER);
	xcont_add(border, xspace_new(15, 4), XCRULE_CENTER);

	w = cp->xpr->width - 50 - xobj_width(nent)- xobj_width(entstr);
	xcont_add(border, xline_new(0, 0, w, 0, cp->xpr->xatborder), 
		  XCRULE_CENTER);
	return border;
}


xobject *
xppage_list_body(struct xpopdic_control *cp, struct dictnode *dnode,
		 unsigned int w, unsigned int h)
{
	xobject *body = xvlayout_new(cp->xpr->bodywidth, -1, 0, XCRULE_TOP);
	int i = 0, wsub = 0;

	for(i = 0; i < dnode->dn_number ; i++){
		xobject *number;
		xobject *entry;
		xobject *hlp = xhlayout_new(cp->xpr->bodywidth, -1, 
					    0, XCRULE_LEFT);
		struct dlistent *dent = dl_list_at(dnode, i);

		wsub = 0;

		/* space */
		if(dnode->dn_number > 9 && (i + 1) < 10){
			xcont_add(hlp, cp->xpc->xo_space, XCRULE_CENTER);
			wsub += xobj_width(cp->xpc->xo_space);
		}
		else	/* just dummy to make index of following posmark same */
			xcont_add(hlp, xspace_new(0, 1), XCRULE_CENTER);

		number = xposmark_new(xpget_listnumber(cp, i + 1));
		wsub += xobj_width(number);
		wsub += xobj_width(cp->xpc->xo_colon);

		entry = xpget_list_entry(dent->dl_title, dent->dl_key, 
					 dent->dl_book, cp, w - wsub);
		
		xcont_add(hlp, number, XCRULE_TOP);
		xcont_add(hlp, cp->xpc->xo_colon, XCRULE_TOP);
		xcont_add(hlp, entry, XCRULE_CENTER);
		xcont_add(body, hlp, XCRULE_LEFT);
	}
	return body;
}
