/*
 *                      xptop.c
 * $Id: xppage_top.c,v 1.4 2004/01/23 09:05:41 hiddy Exp $
 * Copyright (C) 2003 Hideaki Imaizumi <hiddy@sfc.wide.ad.jp>
 *               All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <stdio.h>
#include <string.h>
#include "memory.h"
#include "bitmap.h"
#include "dictbook.h"
#include "booklist.h"
#include "strlist.h"
#include "strset.h"
#include "xobjcache.h"
#include "xwindow.h"
#include "stk/stkbase.h"
#include "xpopdic_resource.h"
#include "xpopdic_component.h"
#include "xpopdic_control.h"
#include "xpobject.h"
#include "xppage.h"
#define mkstr(x,y)	xstring_na_new(x, strlen(x), y, 0)

static const char *msg[] = {
	"X-Popup-Dictionary",
	"  - An application showing a translation of a word indicated by the \"PRIMARY\" selectoin on the X Window system. ",
	NULL
};

static const char *copyright[] = {
	"http://www.sfc.wide.ad.jp/~hiddy/software/xpopdic",
	"Copyright (C) 2004 Hideaki Imaizumi", 
	"All rights reserved.",
	NULL
};

xobject *
xppage_top_border(struct xpopdic_control *cp, struct dictnode *dnode)
{
	xobject *border = xhlayout_new(cp->xpr->width, -1, 0, XCRULE_CENTER);
	/* add border */
	xobject *ver = mkstr("v" XPOPDIC_VERSION, cp->xpr->xatbody);
	int w = cp->xpr->width - 80 - 10 - xobj_width(ver) -10;
	xcont_add(border, xline_new(0, 0, w, 0, cp->xpr->xatborder), XCRULE_CENTER);
	xcont_add(border, xspace_new(10, 4), XCRULE_CENTER);
	xcont_add(border, ver, XCRULE_CENTER);
	xcont_add(border, xspace_new(10, 4), XCRULE_CENTER);
	xcont_add(border, xline_new(0, 0, 80, 0, cp->xpr->xatborder), XCRULE_CENTER);
	return border;
}

xobject *
xppage_top_body(struct xpopdic_control *cp, struct dictnode *dnode, 
		unsigned int w, unsigned int h)
{
	int i = 0;
	xobject *body = xvlayout_new(w, h, 0, XCRULE_TOP);

	/* first line */
	xcont_add(body, xstring_na_new(msg[0], 
			 strlen(msg[0]), cp->xpr->xatgaiji, 0), XCRULE_LEFT);

	for(i = 1; msg[i] ; i++)
		xpput_line(msg[i], body, cp->xpr->bodywidth, NULL, cp);

	xcont_add(body, cp->xpc->xo_expdr, XCRULE_CENTER);
	for(i = 0; copyright[i]; ++i)
		xcont_add(body, mkstr(copyright[i], cp->xpr->xaturl), XCRULE_CENTER);
	xcont_add(body, xspace_new(5, 5), XCRULE_CENTER);
	return body;
}

